#include "modlibgccvb.h"  // gccVB library
#include "notes.h"     // Note constants by DanB
#include "su11sfx.h"   // Sound engine header
#include "su11sfx.c"   // Sound engine implementation
#include "sounddat.h"  // Actual soundssss
#include "titlescreen4char.h"
#include "titlescreen4map.h"
#include "cavefront3char.h"
#include "cavefront3map.h"
#include "caveback2char.h"
#include "caveback2map.h"
#include "cityfrontchar.h"
#include "cityfrontmap.h"
#include "citybackchar.h"
#include "citybackmap.h"
#include "desertfrontchar2.h"
#include "desertfrontmap2.h"
#include "desertbackchar.h"
#include "desertbackmap.h"
#include "underwater2char.h"
#include "underwater2map.h"
#include "sharkschar.h"
#include "sharksmap.h"
#include "snowfgchar.h"
#include "snowfgmap.h"
#include "snowbgchar.h"
#include "snowbgmap.h"
#include "spacefg3char.h"
#include "spacefg3map.h"
#include "spacebgchar.h"
#include "spacebgmap.h"
#include "forestfg3char.h"
#include "forestfg3map.h"
#include "forestbg2char.h"
#include "forestbg2map.h"

#include "beachfg3char.h"
#include "beachfg3map.h"
#include "beachbg3char.h"
#include "beachbg3map.h"

#include "libraryfgchar.h"
#include "libraryfgmap.h"
#include "librarybgchar.h"
#include "librarybgmap.h"

#include "castlefgchar.h"
#include "castlefgmap.h"
#include "castlebgchar.h"
#include "castlebgmap.h"

#include "sprites8char.h"
#include "sprites8map.h"

#include "vbtestchar.h"
#include "vbtestmap.h"

#include "gameoverchar.h"
#include "gameovermap.h"

#include "font_fixed_burgers3.h"
#include "blankthingmap.h"

char scorehundreds_str[2];
char score_str[2];
char lives_str[1];
char level_str[1];
int score, burgery, burgerx, randomtimer, levelintrotimer, bgscroll1, bgscroll2, fryx, fryy, scorehundreds;
int shakex, shakey, shakexplus, shakeyplus, shakeyminus, shakeyplussecond, bgscroll3, bgscroll4;
char gamepart=-2, bgscrolltimer, startpressed, fryshot, level, lives, burgerdead, scrolltimer, enemyspeed, enemyydir, enemydirtimer;
char enemytype, enemytypetimer,  actofringshooting, enemycounter;
int onionring1y, onionring2y, onionring3y, onionringx, oniony, oniondifference;
int onionring1yplus, onionring2yplus, onionring3yplus, onionringxplus;
int onionring1yminus, onionring2yminus, onionring3yminus, onionringxminus, bossshakeyplus, bossshakeyminus;
char enemyshootnow, randomenemyshoot, nuggetdecider, nuggetonscreen, startinglevel;   
int batttest, reston, bgscroll3y, bgscroll4y;
u16 frame;

// the startinglevel thing will be used to see if player starts at beginning so he can see the ending.
// the ending will be only visible to those who start on level 1 and play all the way through.

void fff()
{
	u16 pad_bits = vbReadPad();
	if ((pad_bits & 1) == 1) batttest=1; 
	if ((pad_bits & 1) != 1) batttest=0; 
}

int main()
{

	while (gamepart==-2)
	{
	vbSetWorld(31, WRLD_ON, 0, 0, 0, 0, 0, 0, 0, 0);
	vbSetWorld(30, WRLD_ON|1, 0, 0, 0, 0, 0, 0, 0, 0);	
	vbSetWorld(29, WRLD_ON|1, 0, 0, 0, 0, 0, 0, 0, 0);	
	vbSetWorld(28, WRLD_ON|1, 0, 0, 0, 0, 0, 0, 0, 0);			
	vbSetWorld(27, WRLD_ON|1, 0, 0, 0, 0, 0, 0, 0, 0);		
	vbSetWorld(26, WRLD_ON|1, 0, 0, 0, 0, 0, 0, 0, 0);	
	vbSetWorld(25, WRLD_ON|1, 0, 0, 0, 0, 0, 0, 0, 0);	
	vbSetWorld(24, WRLD_ON|1, 0, 0, 0, 0, 0, 0, 0, 0);	
	vbSetWorld(23, WRLD_ON|1, 0, 0, 0, 0, 0, 0, 0, 0);	
	vbSetWorld(22, WRLD_ON|1, 0, 0, 0, 0, 0, 0, 0, 0);	
	vbSetWorld(21, WRLD_ON|1, 0, 0, 0, 0, 0, 0, 0, 0);	
	vbSetWorld(20, WRLD_ON|1, 0, 0, 0, 0, 0, 0, 0, 0);			
	vbSetWorld(19, WRLD_ON|1, 0, 0, 0, 0, 0, 0, 0, 0);		
	vbSetWorld(18, WRLD_ON|1, 0, 0, 0, 0, 0, 0, 0, 0);	
	vbSetWorld(17, WRLD_ON|1, 0, 0, 0, 0, 0, 0, 0, 0);			
	vbSetWorld(16, WRLD_ON|1, 0, 0, 0, 0, 0, 0, 0, 0);		
	vbSetWorld(15, WRLD_ON|1, 0, 0, 0, 0, 0, 0, 0, 0);	
	
	vbDisplayOn();	
	vbDisplayShow();		
	
	InitSound();	

	burgerx=100, burgery=100, fryshot=0, fryx=-20;
	
		copymem((void*)CharSeg1, (void*)VBTESTCHAR, 512*16);
		copymem((void*)BGMap(1), (void*)VBTESTMAP, 512*16);	
	
		copymem((void*)CharSeg3, (void*)FONT_FIXED_BURGERS3, 512*16);	
		copymem((void*)BGMap(3), (void*)BLANKTHINGMAP, 512*16);		
			
	gamepart=-1;
	}	
	
while (gamepart==-1)
		{
		// wait for the VIP to finish drawing
    while(!(VIP_REGS[INTPND] & XPEND)); 
    VIP_REGS[INTCLR]= XPEND; 	
	
		vbSetWorld(31, WRLD_LON|1, 0, 0, 0, 0, 0, 0, 384, 224);
		vbSetWorld(30, WRLD_RON|1, 0, 0, 0, 0, 0, 224, 384, 224);	
	
		VIP_REGS[GPLT2]=0x24;  // burger outline
	
		randomtimer++;
		
		if (randomtimer<32) randomtimer=32;
		if (randomtimer>200) randomtimer=32;
	
		if ((vbReadPad()&K_STA) && (startpressed==0)) startpressed=1;
		if (!(vbReadPad()&K_STA) && (startpressed==1)) 
			{
			startpressed=0, score=0, burgery=56, reston=1;			

			vbTextOut(2,12,5,"enable auto pause");
			vbTextOut(2,12,6,"after 15 minutes?");
			
			vbTextOut(2,14,7,"yes");
			vbTextOut(2,14,9,"no ");

			//

			vbSetWorld(30, WRLD_ON|1, 0, 0, 0, 0, 0, 0, 0, 0);
			vbSetWorld(31, WRLD_ON|2, 0, 0, 0, 0, 0, 0, 0, 0);	
			
			copymem((void*)CharSeg1, (void*)SPRITES8CHAR, 512*16); 
			copymem((void*)BGMap(1), (void*)SPRITES8MAP, 512*16);					
			vbDisplayShow();
			
			gamepart=-3;
			}
		}
	
while (gamepart==-3)
	{
			while(!(VIP_REGS[INTPND] & XPEND)); 
			VIP_REGS[INTCLR]= XPEND; 	
	
			vbSetWorld(30, WRLD_ON|1, 144, -2, burgery, 0, 0, 0, 15, 15);
			vbSetWorld(31, WRLD_ON|2, 0, 0, 0, 0, 0, 0, 384, 80);				

			if (vbReadPad()&K_LU) reston=1, frame=0, burgery=56;
			if (vbReadPad()&K_LD) reston=0, frame=0, burgery=72;			
			if ((vbReadPad()&K_STA) && (startpressed==0)) startpressed=1;
			if (!(vbReadPad()&K_STA) && (startpressed==1)) startpressed=0, level=10, gamepart=0;
			}	
	
while (gamepart==0)
		{
		
			copymem((void*)BGMap(2), (void*)BLANKTHINGMAP, 512*16);			
			vbSetWorld(31, WRLD_ON|1, 0, 0, 0, 0, 0, 0, 0, 0);
			vbSetWorld(30, WRLD_ON|1, 0, 0, 0, 0, 0, 0, 0, 0);
			vbSetWorld(29, WRLD_ON|1, 0, 0, 0, 0, 0, 0, 0, 0);	
			vbSetWorld(28, WRLD_ON|1, 0, 0, 0, 0, 0, 0, 0, 0);			
			vbSetWorld(27, WRLD_ON|1, 0, 0, 0, 0, 0, 0, 0, 0);		
			vbSetWorld(26, WRLD_ON|1, 0, 0, 0, 0, 0, 0, 0, 0);	
			vbSetWorld(25, WRLD_ON|1, 0, 0, 0, 0, 0, 0, 0, 0);	
			vbSetWorld(24, WRLD_ON|1, 0, 0, 0, 0, 0, 0, 0, 0);	
			vbSetWorld(23, WRLD_ON|1, 0, 0, 0, 0, 0, 0, 0, 0);	
			vbSetWorld(22, WRLD_ON|1, 0, 0, 0, 0, 0, 0, 0, 0);	
			vbSetWorld(21, WRLD_ON|1, 0, 0, 0, 0, 0, 0, 0, 0);	
			vbSetWorld(20, WRLD_ON|1, 0, 0, 0, 0, 0, 0, 0, 0);		
			vbSetWorld(19, WRLD_ON|1, 0, 0, 0, 0, 0, 0, 0, 0);		
			vbSetWorld(18, WRLD_ON|1, 0, 0, 0, 0, 0, 0, 0, 0);	
			vbSetWorld(17, WRLD_ON|1, 0, 0, 0, 0, 0, 0, 0, 0);			
			vbSetWorld(16, WRLD_ON|1, 0, 0, 0, 0, 0, 0, 0, 0);
			vbSetWorld(15, WRLD_ON|1, 0, 0, 0, 0, 0, 0, 0, 0);	
			
			scorehundreds_str[0]=(scorehundreds/10)+'0';
			scorehundreds_str[1]=(scorehundreds%10)+'0'; 
			score_str[0]=(score/10)+'0'; 
			score_str[1]=(score%10)+'0'; 
		
			vbTextOut(2,0,0,"score ");	
			vbTextOut(2,6,0,scorehundreds_str);
			vbTextOut(2,8,0,score_str);	
		
			vbTextOut(2,10,0,"   "); // gets rid of three medium shaded squares if battery is not low.
			PlaySound(titlescreen);	
			PlaySound(titlescreen2);

			burgerx=16, burgery=16, randomtimer=16;
			burgerdead=0, startpressed=0;
			
			copymem((void*)CharSeg0, (void*)TITLESCREEN4CHAR, 512*16);
			copymem((void*)BGMap(0), (void*)TITLESCREEN4MAP, 512*16);	

			gamepart=1;
		}
	
while (gamepart==1)	
	{
    // wait for the VIP to finish drawing
    while(!(VIP_REGS[INTPND] & XPEND)); 
    VIP_REGS[INTCLR]= XPEND; 	
	
	vbSetWorld(28, WRLD_ON|2, 0, 0, 0, 0, 0, 0, 255, 199); 

	vbSetWorld(29, WRLD_ON|1, fryx, -2, fryy, 16, 0, 25, 16, 16);  // fry outline
	vbSetWorld(18, WRLD_ON|1, fryx, -2, fryy, 16, 0, 0, 16, 16);	// actual fry
	
	vbSetWorld(30, WRLD_ON|1, burgerx, -2, burgery, 0, 0, 24, 15, 16);
	vbSetWorld(19, WRLD_ON|1, burgerx, -2, burgery, 0, 0, 0, 15, 16);
	
	vbSetWorld(31, WRLD_ON, 0, 0, 0, 0, 0, 0, 384, 224);	
	DoSounds();		
	randomtimer++;
	if ((vbReadPad()&K_LU) && (burgery>16)) burgery=burgery-2, randomtimer++;
	if ((vbReadPad()&K_LD) && (burgery<200)) burgery=burgery+2, randomtimer++;		
	if ((vbReadPad()&K_LL) && (burgerx>16)) burgerx=burgerx-2, randomtimer++;
	if ((vbReadPad()&K_LR) && (burgerx<354)) burgerx=burgerx+2, randomtimer++;	
	
	if (fryshot==1) PlaySound(burgershoot), fryx=burgerx, fryy=burgery, fryshot=2;
	if (fryshot==2) fryx=fryx+4;
	if ((fryx>384) && (fryshot==2)) fryx=-20, fryshot=3;
	if ((fryshot==3) && (!(vbReadPad()&K_A))) fryshot=0;
	if ((vbReadPad()&K_A) && (fryshot==0)) randomtimer++, fryshot=1;		
	
	fff();	
	// low battery?
	if (batttest==1) vbTextOut(2,11,0,"!"); // if battery is low then display battery symbol.
	if (batttest==0) vbTextOut(2,11,0," "); // if battery isn't low then don't display battery 		
	
	// ! - battery symbol. I changed it.	
	
	if (randomtimer<32) randomtimer=32;
	if (randomtimer>200) randomtimer=32;
	
	if ((vbReadPad()&K_STA) && (startpressed==0)) startpressed=1;
	if (!(vbReadPad()&K_STA) && (startpressed==1)) startpressed=0, scorehundreds=0, score=0, gamepart=2, lives=3;
	
	// temporary level select.
	level_str[0]=(level%10)+'0';
	vbTextOut(2,0,1,"level ");
	
	if (level<10) vbTextOut(2,6,1,level_str), vbTextOut(2,7,1,"      ");	
	if (level==10) vbTextOut(2,6,1,"10"), vbTextOut(2,8,1,"     ");
	
	vbTextOut(2,16,24,"$2021 Chris Read.");	
	 // $ is copyright symbol. I changed it.
	
	if ((vbReadPad()&K_RU) && (startpressed==0)) startpressed=2;
	if (!(vbReadPad()&K_RU) && (startpressed==2)) 
		{
		if (level<10) level++;			
		startpressed=0;
		}
	
	if ((vbReadPad()&K_RD) && (startpressed==0)) startpressed=3;
	if (!(vbReadPad()&K_RD) && (startpressed==3))
		{
		if (level>1) level--;			
		startpressed=0;
		}
	
	}
	
while (gamepart==2)
	{
	vbSetWorld(31, WRLD_ON, 0, 0, 0, 0, 0, 0, 0, 0);
	vbSetWorld(30, WRLD_ON|1, 0, 0, 0, 0, 0, 0, 0, 0);	
	vbSetWorld(29, WRLD_ON|1, 0, 0, 0, 0, 0, 0, 0, 0);	
	vbSetWorld(28, WRLD_ON|1, 0, 0, 0, 0, 0, 0, 0, 0);			
	vbSetWorld(27, WRLD_ON|1, 0, 0, 0, 0, 0, 0, 0, 0);		
	vbSetWorld(26, WRLD_ON|1, 0, 0, 0, 0, 0, 0, 0, 0);	
	vbSetWorld(25, WRLD_ON|1, 0, 0, 0, 0, 0, 0, 0, 0);	
	vbSetWorld(24, WRLD_ON|1, 0, 0, 0, 0, 0, 0, 0, 0);	
	vbSetWorld(23, WRLD_ON|1, 0, 0, 0, 0, 0, 0, 0, 0);	
	vbSetWorld(22, WRLD_ON|1, 0, 0, 0, 0, 0, 0, 0, 0);	
	vbSetWorld(21, WRLD_ON|1, 0, 0, 0, 0, 0, 0, 0, 0);	
	vbSetWorld(20, WRLD_ON|1, 0, 0, 0, 0, 0, 0, 0, 0);	
	vbSetWorld(19, WRLD_ON|1, 0, 0, 0, 0, 0, 0, 0, 0);		
	
	bgscroll3y=0, bgscroll4y=0;
	bgscroll3=0, bgscroll4=384;

	randomenemyshoot=-127;
	burgerx=20, burgery=100;	
	StopAllSounds();
	
	VIP_REGS[GPLT0]=0xE4;		
	VIP_REGS[GPLT1]=0x90;
	switch (level)
		{
		case 1:
		PlaySound(levelone1);	
		PlaySound(levelone2);	
		copymem((void*)CharSeg0, (void*)CAVEFRONT3CHAR, 512*16);
		copymem((void*)BGMap(0), (void*)CAVEFRONT3MAP, 512*16);		
		copymem((void*)CharSeg2, (void*)CAVEBACK2CHAR, 512*16);
		copymem((void*)BGMap(2), (void*)CAVEBACK2MAP, 512*16);			
		break;
		
		case 2:
		enemyshootnow=95;
		PlaySound(leveltwo1);	
		PlaySound(leveltwo2);	
		copymem((void*)CharSeg0, (void*)CITYFRONTCHAR, 512*16);
		copymem((void*)BGMap(0), (void*)CITYFRONTMAP, 512*16);		
		copymem((void*)CharSeg2, (void*)CITYBACKCHAR, 512*16);
		copymem((void*)BGMap(2), (void*)CITYBACKMAP, 512*16);			
		break;
		
		case 3:
		enemyshootnow=64;
		PlaySound(levelthree1);	
		PlaySound(levelthree2);	
		copymem((void*)CharSeg0, (void*)DESERTFRONTCHAR2, 512*16);
		copymem((void*)BGMap(0), (void*)DESERTFRONTMAP2, 512*16);		
		copymem((void*)CharSeg2, (void*)DESERTBACKCHAR, 512*16);
		copymem((void*)BGMap(2), (void*)DESERTBACKMAP, 512*16);			
		break;
		
		case 4:
		enemyshootnow=48;
		PlaySound(levelfour1);	
		PlaySound(levelfour2);	
		copymem((void*)CharSeg0, (void*)UNDERWATER2CHAR, 512*16);
		copymem((void*)BGMap(0), (void*)UNDERWATER2MAP, 512*16);		
		copymem((void*)CharSeg2, (void*)SHARKSCHAR, 512*16);
		copymem((void*)BGMap(2), (void*)SHARKSMAP, 512*16);			
		break;
		
		case 5:
		enemyshootnow=32;
		PlaySound(levelfive1);	
		PlaySound(levelfive2);	
		copymem((void*)CharSeg0, (void*)SNOWFGCHAR, 512*16);
		copymem((void*)BGMap(0), (void*)SNOWFGMAP, 512*16);		
		copymem((void*)CharSeg2, (void*)SNOWBGCHAR, 512*16);
		copymem((void*)BGMap(2), (void*)SNOWBGMAP, 512*16);		
		bgscroll3y=-234, bgscroll4y=0;
		bgscroll3=0, bgscroll4=0;
		break;		
		
		case 6:
		enemyshootnow=16;
		PlaySound(levelsix1);	
		PlaySound(levelsix2);	
		copymem((void*)CharSeg0, (void*)SPACEFG3CHAR, 512*16);
		copymem((void*)BGMap(0), (void*)SPACEFG3MAP, 512*16);		
		copymem((void*)CharSeg2, (void*)SPACEBGCHAR, 512*16);
		copymem((void*)BGMap(2), (void*)SPACEBGMAP, 512*16);		
		break;			
		
		case 7:
		enemyshootnow=0;
		PlaySound(levelseven1);	
		PlaySound(levelseven2);	
		copymem((void*)CharSeg0, (void*)FORESTFG3CHAR, 512*16);
		copymem((void*)BGMap(0), (void*)FORESTFG3MAP, 512*16);		
		copymem((void*)CharSeg2, (void*)FORESTBG2CHAR, 512*16);
		copymem((void*)BGMap(2), (void*)FORESTBG2MAP, 512*16);		
		break;		
		
		case 8:
		enemyshootnow=-16;		
		PlaySound(leveleight1);	
		PlaySound(leveleight2);	
		copymem((void*)CharSeg0, (void*)BEACHFG3CHAR, 512*16);
		copymem((void*)BGMap(0), (void*)BEACHFG3MAP, 512*16);		
		copymem((void*)CharSeg2, (void*)BEACHBG3CHAR, 512*16);
		copymem((void*)BGMap(2), (void*)BEACHBG3MAP, 512*16);
		break;			
		
		case 9:
		enemyshootnow=-32;		
		//PlaySound(leveleight1);	
		//PlaySound(leveleight2);	
		copymem((void*)CharSeg0, (void*)LIBRARYFGCHAR, 512*16);
		copymem((void*)BGMap(0), (void*)LIBRARYFGMAP, 512*16);		
		copymem((void*)CharSeg2, (void*)LIBRARYBGCHAR, 512*16);
		copymem((void*)BGMap(2), (void*)LIBRARYBGMAP, 512*16);
		break;			
	
		case 10:	
		PlaySound(levelten1);	
		PlaySound(levelten2);	
		copymem((void*)CharSeg0, (void*)CASTLEFGCHAR, 512*16);
		copymem((void*)BGMap(0), (void*)CASTLEFGMAP, 512*16);		
		copymem((void*)CharSeg2, (void*)CASTLEBGCHAR, 512*16);
		copymem((void*)BGMap(2), (void*)CASTLEBGMAP, 512*16);
		break;			
		
		default:
		break;	
		}

	
	
	
	randomtimer=32;
	shakey=randomtimer, shakex=-17;
	//copymem((void*)CharSeg3, (void*)FONT_FIXED_BURGERS, 512*16);
	levelintrotimer=1;
	bgscroll1=0, bgscroll2=384;

	fryx=-20, fryshot=0, burgerdead=0, enemyspeed=2, enemyydir=0, shakey=400, oniondifference=32;
	enemycounter=-1; // make -1 when done.

	//enemycounter=78;

	onionringx=-25, actofringshooting=2;
	gamepart=3;	
	// wait for the VIP to finish drawing
	while(!(VIP_REGS[INTPND] & XPEND)); 
	VIP_REGS[INTCLR]= XPEND; 			
	
	//vbDisplayShow();
	the_main_game();
	}
	}

//	 the main game stuff.
int the_main_game()
{
	while (gamepart==3) {
		
		
			
		if (level==11) gamepart=0, shakex=400, level=10, StopAllSounds(), main();		
	
		if ((reston==1) && (startpressed==0) && (frame<45000)) frame++;
		if (frame==45000) PauseAllSounds(), frame=45001, startpressed=15, reston=2;
	
		randomenemyshoot++;
	
		randomtimer++;
		if (randomtimer>200) randomtimer=16;
		
		enemydirtimer++;
		if (enemydirtimer>2) enemydirtimer=1;

		enemytypetimer++;
		if (enemytypetimer>3) enemytypetimer=1;	

		oniony++;
		if (oniony>150) oniony=52;
		
		oniondifference++;
		if (oniondifference>70) oniondifference=32;
		
		nuggetdecider++;

		vbSetWorld(29, WRLD_ON, bgscroll1, 0, 0, 0, 0, 0, 384, 224); 	
		vbSetWorld(28, WRLD_ON, bgscroll2, 0, 0, 0, 0, 0, 384, 224); 	
	
		vbSetWorld(30, WRLD_ON|2, bgscroll3, 2, bgscroll3y, 0, 0, 0, 384, 224); 	
		vbSetWorld(31, WRLD_ON|2, bgscroll4, 2, bgscroll4y, 0, 0, 0, 384, 224); 	

		vbSetWorld(27, WRLD_ON|1, burgerx, -2, burgery, 0, 0, 24, 15, 16);
		vbSetWorld(19, WRLD_ON|1, burgerx, -2, burgery, 0, 0, 0, 15, 16);
	
		vbSetWorld(26, WRLD_ON|1, fryx, -2, fryy, 16, 0, 25, 16, 16);  // fry outline
		vbSetWorld(18, WRLD_ON|1, fryx, -2, fryy, 16, 0, 0, 16, 16);	// actual fry	
		
		if (enemycounter<80) 
			{
			vbSetWorld(25, WRLD_ON|1, shakex, -2, shakey, 32, 0, 24, 13, 24);	
			vbSetWorld(17, WRLD_ON|1, shakex, -2, shakey, 32, 0, 0, 12, 23);		
			
			if (nuggetonscreen==1) 
				{
				vbSetWorld(25, WRLD_ON|1, shakex, -2, shakey, 64, 0, 24, 18, 17);
				vbSetWorld(17, WRLD_ON|1, shakex, -2, shakey, 63, 0, 0, 16, 16);	
				}
			}
		
		if (enemycounter>79)
			{
			vbSetWorld(25, WRLD_ON|1, shakex, -2, shakey, 104, 0, 0, 56, 100);
			
			if (levelintrotimer<100) burgerdead=2;
			if ((levelintrotimer==100) && (burgerdead==2)) burgerdead=0;
			
			if ((shakex<300) && (burgerdead==0))
				{
				vbSetWorld(15, WRLD_ON|1, onionringx, -2, onionring1y, 47, 0, 0, 16, 16);
				vbSetWorld(24, WRLD_ON|1, onionringx, -2, onionring1y, 48, 0, 24, 15, 17);					
				
				vbSetWorld(17, WRLD_ON|1, onionringx, -2, onionring2y, 47, 0, 0, 16, 16);	
				vbSetWorld(23, WRLD_ON|1, onionringx, -2, onionring2y, 48, 0, 24, 15, 17);					
				
				vbSetWorld(16, WRLD_ON|1, onionringx, -2, onionring3y, 47, 0, 0, 16, 16);	
				vbSetWorld(22, WRLD_ON|1, onionringx, -2, onionring3y, 48, 0, 24, 15, 17);	
				}
				
			if (shakex>299) 
				{
				vbSetWorld(24, WRLD_ON|1, 0, 0, 0, 0, 0, 0, 0, 0);	
				vbSetWorld(23, WRLD_ON|1, 0, 0, 0, 0, 0, 0, 0, 0);	
				vbSetWorld(22, WRLD_ON|1, 0, 0, 0, 0, 0, 0, 0, 0);			
				
				vbSetWorld(15, WRLD_ON|1, 0, 0, 0, 0, 0, 0, 0, 0);	
				vbSetWorld(17, WRLD_ON|1, 0, 0, 0, 0, 0, 0, 0, 0);	
				vbSetWorld(16, WRLD_ON|1, 0, 0, 0, 0, 0, 0, 0, 0);						
				
				}	
	
			if (burgerdead>0) 
				{
				vbSetWorld(24, WRLD_ON|1, 0, 0, 0, 0, 0, 0, 0, 0);	
				vbSetWorld(23, WRLD_ON|1, 0, 0, 0, 0, 0, 0, 0, 0);	
				vbSetWorld(22, WRLD_ON|1, 0, 0, 0, 0, 0, 0, 0, 0);		

				vbSetWorld(15, WRLD_ON|1, 0, 0, 0, 0, 0, 0, 0, 0);	
				vbSetWorld(17, WRLD_ON|1, 0, 0, 0, 0, 0, 0, 0, 0);	
				vbSetWorld(16, WRLD_ON|1, 0, 0, 0, 0, 0, 0, 0, 0);		
				}	
	
			}
		
		vbSetWorld(20, WRLD_ON|3, 120, -4, 0, 0, 0, 0, 159, 111); 

		scorehundreds_str[0]=(scorehundreds/10)+'0';
		scorehundreds_str[1]=(scorehundreds%10)+'0'; 
		score_str[0]=(score/10)+'0'; 
		score_str[1]=(score%10)+'0'; 
		
		vbTextOut(3,0,0,"score ");	
		vbTextOut(3,6,0,scorehundreds_str);
		vbTextOut(3,8,0,score_str);
		vbTextOut(3,10,0," lives ");   // gets rid of a printed 'd' on there for some reason.
		lives_str[0]=(lives%10)+'0';		
		vbTextOut(3,17,0,lives_str);		
	
		fff();	
	// low battery?
	if (batttest==1) vbTextOut(3,19,0,"!"); // if battery is low then display battery symbol.
	if (batttest==0) vbTextOut(3,19,0," "); // if battery isn't low then don't display battery 		
	
	    // wait for the VIP to finish drawing
		while(!(VIP_REGS[INTPND] & XPEND)); 
		VIP_REGS[INTCLR]= XPEND; 		
	
		onionringxplus=onionringx+16, onionringxminus=onionringx-16, onionring1yminus=onionring1y-13, onionring1yplus=onionring1y+13; 
	
		if ((enemycounter>19) && (enemycounter<40)) enemytype=2;
		if ((enemycounter>39) && (enemycounter<60)) enemytype=3;
		
		if (score==100) score=0, scorehundreds++;		
		
		// boss part.
		if (enemycounter>79)
			{
			if ((startpressed==0) && (shakex==299))
				{
				bossshakeyminus=50, bossshakeyplus=134;
				enemytype=0;
				// boss shake moving up and down past level 2.
				if ((level>2) && (level<6))
					{
					bossshakeyminus=shakey-5, bossshakeyplus=shakey+84;
					if (shakey>200) enemyydir=1;
					if (shakey<32) enemyydir=2;		
					if ((enemyydir==1) && (startpressed==0)) shakey--;
					if ((enemyydir==2) && (startpressed==0)) shakey++;						
					}
				
				if (level>5)
					{
					bossshakeyminus=shakey-5, bossshakeyplus=shakey+84;
					if (shakey>200) enemyydir=1;
					if (shakey<32) enemyydir=2;		
					if ((enemyydir==1) && (startpressed==0)) shakey=shakey-2;
					if ((enemyydir==2) && (startpressed==0)) shakey=shakey+2;						
					}				
				
				onionringx=onionringx-3;
				if ((fryx>305) && (fryx<364) && (fryy>bossshakeyminus) && (fryy<bossshakeyplus)) 
					{
					PlaySound(shake_hit), enemycounter++, score++, fryshot=3, fryx=-20;
	
					}
				if ((burgerx>298) && (burgerx<364) && (burgery>50) && (burgery<134) && (burgerdead==0)) burgerdead=1;		
					
					onionring2yminus=onionring2y-13, onionring3yminus=onionring3y-13; 
					onionring2yplus=onionring2y+13, onionring3yplus=onionring3y+13; 
					}
			
			// if zybort touches onion rings, kill him.
		if ((burgerx>onionringxminus) && (burgerx<onionringxplus))
			{
			if ((burgery>onionring1yminus) && (burgery<onionring1yplus)) burgerdead=1;
			if ((burgery>onionring2yminus) && (burgery<onionring2yplus)) burgerdead=1;
			if ((burgery>onionring3yminus) && (burgery<onionring3yplus)) burgerdead=1;		
			}
		
			if ((onionringx<-17) && (shakex==299) && (burgerdead==0) && (enemycounter<100)) onionring1y=oniony, onionring2y=oniony+oniondifference, onionring3y=oniony-oniondifference, onionringx=299;
			if ((onionringx<-17) && (enemycounter==100)) onionringx=-20;
			if ((onionringx<-17) && (enemycounter==80) && (shakex>299)) enemyydir=1, onionringx=-20;		
			if (onionring3y<24) onionring3y=24;	
			
			}
			
		switch (enemytype)
			{
			case 1:
			enemyspeed=2;
			enemydirtimer=0;
			break;
		
			case 2:
			enemyspeed=3;
			enemydirtimer=0;		
			break;
		
			case 3:
			enemyspeed=2;
			if ((enemycounter>39) && (shakey>200)) enemyydir=1;
			if ((enemycounter>39) && (shakey<16)) enemyydir=2;
			if ((enemyydir==1) && (startpressed==0)) shakey=shakey-2;
			if ((enemyydir==2) && (startpressed==0)) shakey=shakey+2;	
			break;
		
			default:
			break;
			}
		
		if (shakex<-17) enemycounter++, actofringshooting=2, shakex=400;
		
		if ((shakex==400) && (enemycounter<80) && (levelintrotimer>99)) 
			{
			shakey=randomtimer, shakex=384, nuggetonscreen=0;	
			if (level==10) actofringshooting=1;	
		
			if ((nuggetdecider<-117) && (level>1) && (enemycounter<80) && (lives<9)) actofringshooting=0, nuggetonscreen=1;	
			}
	
		if ((shakex==384) && (burgerdead<2))
			{	
			if ((enemycounter>39) && (enemycounter<60)) enemyydir=enemydirtimer, enemytype=3;
			if ((enemycounter>59) && (enemycounter<80)) enemytype=enemytypetimer;
			}
			
		if ((level>1) && (onionringx<-23) && (enemycounter<80) && (actofringshooting==2))
				{
				actofringshooting=0, onionringx=-23;
				if (randomenemyshoot>enemyshootnow) actofringshooting=1;	
				}

		if (enemycounter==100)
			{
			if ((onionringx<-17) && (startpressed==0))
				{
				onionringx=-20, burgerdead=3;
				if (shakex<400) shakex++;
				if (shakex==400) burgerx++;
				if (burgerx==400) gamepart=2, shakex=400, level++, StopAllSounds(), main();	
				}
			}

		if ((enemycounter==80) && (shakex==301)) StopAllSounds(), PlaySound(bossfight1), PlaySound(bossfight2);

		if ((enemycounter>79) && (levelintrotimer>99) && (enemycounter<100) && (startpressed==0) && (shakex>299)) onionringx=-20, burgerdead=2, shakey=50, shakex--;		
		if ((enemycounter>79) && (enemycounter<100) && (shakex==300)) burgerdead=0, fryshot=0, shakex=299, onionring1y=oniony, onionring2y=oniony+oniondifference, onionring3y=oniony-oniondifference;

		if ((burgerdead==1) && (startpressed==0) && (levelintrotimer==100)) fryx=400, fryshot=0, burgery=burgery+4, onionringx=-25;
			
		if ((burgery>224) && (enemycounter<80)) shakex=400;
		
		if ((level==10) && (levelintrotimer>99) && (nuggetonscreen==0) && (enemycounter<80)) actofringshooting=1;
					
		if (burgery>224) lives--, burgerx=20, burgery=100, burgerdead=0, levelintrotimer=1;
		if (lives==-1) StopAllSounds(), gamepart=66, gameover();			
		
		if (levelintrotimer<100)
			{
			actofringshooting=0, onionringx=-25;
			levelintrotimer++;		
			level_str[0]=(level%10)+'0';
			
			if (level<10) vbTextOut(3,11,13,level_str), vbTextOut(3,5,13,"level");	
			if (level==10) vbTextOut(3,5,13,"level 10");	
			}
		
		if (levelintrotimer>99) vbTextOut(3,5,13,"         ");
		if ((startpressed==0) && (levelintrotimer>99)) vbTextOut(3,5,13,"         ");
		
		if (bgscroll1==-384) bgscroll1=384;
		if (bgscroll2==-384) bgscroll2=384;
		
		if (bgscroll3==-384) bgscroll3=384;
		if (bgscroll4==-384) bgscroll4=384;		
		
		if ((vbReadPad()&K_STA) && (levelintrotimer==100) && (startpressed==0)) randomtimer++, startpressed=1;
		if (!(vbReadPad()&K_STA) && (startpressed==1)) randomtimer++, startpressed=2;	
		
		if (startpressed>0)  
			{
			if (frame<45001) vbTextOut(3,5,13,"paused.");
			PauseAllSounds();
			}
			
		if (reston>1) 
			{
			vbTextOut(3,5,12,"take a ");
			vbTextOut(3,5,13,"break. ");
			if ((vbReadPad()&K_STA) && (reston==2)) reston=3;
			if (!(vbReadPad()&K_STA) && (reston==3)) vbTextOut(3,5,12,"       "), reston=1, frame=0, startpressed=0;	
			}		
			
		if (startpressed==0) DoSounds();	
		
		if ((vbReadPad()&K_STA) && (reston<2) && (startpressed==2)) startpressed=3;
		if (!(vbReadPad()&K_STA) && (reston<2) && (startpressed==3)) startpressed=0;	

	if (startpressed==0)
		{
		scrolltimer++;
		
		if (level==5) 
				{
				bgscroll3y++, bgscroll4y++, scrolltimer=0;
				if (bgscroll3y>244) bgscroll3y=-234;
				if (bgscroll4y>244) bgscroll4y=-234;
				}		
		
		if (level==10) scrolltimer=2;
			
		if ((burgerdead<3) && (enemycounter<80))
			{
			bgscroll1--, bgscroll2--;	
			if ((scrolltimer==2) && (level !=5)) bgscroll3--, bgscroll4--, scrolltimer=0;
			}
			
		if ((levelintrotimer>99) && (enemycounter<80)) shakex=shakex-enemyspeed;
		
		if (fryshot==1) PlaySound(burgershoot), fryx=burgerx, fryy=burgery, fryshot=2;
		if (fryshot==2) fryx=fryx+4;
		if ((fryx>384) && (fryshot==2)) fryx=-20, fryshot=3;
		if ((fryshot==3) && (!(vbReadPad()&K_A))) fryshot=0;

		if (burgerdead==0)
			{
			if ((vbReadPad()&K_A) && (enemycounter<100) && (fryshot==0)) randomtimer++, fryshot=1;	
			
			if (enemycounter<80)
				{
				shakexplus=shakex+15, shakeyminus=shakey-15, shakeyplus=shakey+12, shakeyplussecond=shakey+20;
				if ((fryx>shakex) && (fryx<shakexplus) && (fryy>shakeyminus) && (fryy<shakeyplus) && (fryshot==2)) 
					{
					PlaySound(shake_hit), fryshot=3, fryx=-20, shakex=400, actofringshooting=2;	
					if (nuggetonscreen==0) enemycounter++, score++;
					}
				
				if ((burgerx>shakex) && (burgerx<shakexplus) && (burgery>shakeyminus) && (burgery<shakeyplussecond)) 	
					{
					if (nuggetonscreen==0) burgerdead=1;
					if (nuggetonscreen==1) lives++, shakex=400, PlaySound(extra_life);
					}
				}
				
			if ((vbReadPad()&K_LU) && (burgery>8)) oniondifference++, burgery=burgery-2, enemytypetimer++, randomtimer++;
			if ((vbReadPad()&K_LD) && (burgery<200)) oniondifference++, burgery=burgery+2, enemytypetimer++, randomtimer++;	
			if ((vbReadPad()&K_LL) && (burgerx>16)) oniondifference++, burgerx=burgerx-2, enemytypetimer++, randomtimer++;
			if ((vbReadPad()&K_LR) && (burgerx<354))  oniondifference++, burgerx=burgerx+2, enemytypetimer++, randomtimer++;		
			}
	
		// onion ring shooting for non-boss.
		if ((level>1) && (enemycounter<80)) 
			{
			vbSetWorld(16, WRLD_ON|1, onionringx, -2, onionring1y, 47, 0, 0, 15, 16);
			vbSetWorld(24, WRLD_ON|1, onionringx, -2, onionring1y, 48, 0, 24, 15, 17);
			}
			
		if ((level>1) && (levelintrotimer>99))
			{
			if ((actofringshooting>0) && (enemycounter<80)) onionringx=onionringx-4;	
			if ((actofringshooting==0) && (enemycounter<80)) onionring1y=400;
			
			if ((onionringx<-24) && (enemycounter<80))
				{
				onionringx=-24;
				if ((actofringshooting==1) && (burgerdead==0)) onionringx=shakex, onionring1y=shakey, PlaySound(shakeshoot);	
				}
			
			if ((burgerx>onionringxminus) && (burgerx<onionringxplus) && (burgery>onionring1yminus) && (burgery<onionring1yplus)) actofringshooting=0, burgerdead=1;			
			}
			
		}
		
	}
	
	
	}
	
int gameover()
{

while (gamepart==66)
	{
	//vbDisplayHide();	
	
	vbSetWorld(31, WRLD_ON, 0, 0, 0, 0, 0, 0, 0, 0);
	vbSetWorld(30, WRLD_ON, 0, 0, 0, 0, 0, 0, 0, 0);	
	
	vbSetWorld(20, WRLD_ON|3, 0, 0, 0, 0, 0, 0, 0, 0); 			
	vbSetWorld(29, WRLD_ON, 0, 0, 0, 0, 0, 0, 0, 0);
	vbSetWorld(28, WRLD_ON, 0, 0, 0, 0, 0, 0, 0, 0);		
	
	vbSetWorld(26, WRLD_ON|1, 0, 0, 0, 0, 0, 0, 0, 0);	
	vbSetWorld(25, WRLD_ON|1, 0, 0, 0, 0, 0, 0, 0, 0);	
	vbSetWorld(24, WRLD_ON|1, 0, 0, 0, 0, 0, 0, 0, 0);	
	vbSetWorld(23, WRLD_ON|1, 0, 0, 0, 0, 0, 0, 0, 0);	
	vbSetWorld(22, WRLD_ON|1, 0, 0, 0, 0, 0, 0, 0, 0);	
	vbSetWorld(21, WRLD_ON|1, 0, 0, 0, 0, 0, 0, 0, 0);	
	vbSetWorld(27, WRLD_ON|1, 0, 0, 0, 0, 0, 0, 0, 0);			
	vbSetWorld(19, WRLD_ON|1, 0, 0, 0, 0, 0, 0, 0, 0);		
	vbSetWorld(18, WRLD_ON|1, 0, 0, 0, 0, 0, 0, 0, 0);	
	vbSetWorld(17, WRLD_ON|1, 0, 0, 0, 0, 0, 0, 0, 0);			
	vbSetWorld(16, WRLD_ON|1, 0, 0, 0, 0, 0, 0, 0, 0);		
	vbSetWorld(15, WRLD_ON|1, 0, 0, 0, 0, 0, 0, 0, 0);		
	
			startpressed=0;
			
			copymem((void*)CharSeg0, (void*)GAMEOVERCHAR, 512*16);
			copymem((void*)BGMap(0), (void*)GAMEOVERMAP, 512*16);
			
			copymem((void*)BGMap(2), (void*)BLANKTHINGMAP, 512*16);			
			
			vbTextOut(3,5,12,"         ");
			vbTextOut(3,5,13,"         ");		
		
	vbSetWorld(31, WRLD_ON|2, 0, 0, 0, 0, 0, 0, 0, 0);			
	vbSetWorld(30, WRLD_ON|2, 0, 0, 0, 0, 0, 0, 0, 0);	
	
	vbSetWorld(20, WRLD_ON|3, 120, -4, 0, 0, 0, 0, 159, 7); 			
	vbSetWorld(29, WRLD_ON, 0, 2, 0, 0, 0, 0, 384, 95);
	vbSetWorld(28, WRLD_ON, 0, 0, 95, 0, 0, 95, 384, 128);	
	
			while(!(VIP_REGS[INTPND] & XPEND)); 
			VIP_REGS[INTCLR]= XPEND; 
	
			vbDisplayShow();	
	
			PlaySound(gameover1);
			PlaySound(gameover2);
			randomtimer=0;
			gamepart=67;
			}		
			
while (gamepart==67)
			{
			while(!(VIP_REGS[INTPND] & XPEND)); 
			VIP_REGS[INTCLR]= XPEND; 
			DoSounds();
			if (randomtimer<190) randomtimer++;
			
			if ((vbReadPad()&K_STA) && (randomtimer>189) && (startpressed==0)) startpressed=1;
			if (!(vbReadPad()&K_STA) && (startpressed==1)) startpressed=0, gamepart=0, StopAllSounds(), main();			
			}
	
}